=== modified file 'NEWS'
--- NEWS	2007-02-08 03:10:33 +0000
+++ NEWS	2007-02-08 16:28:05 +0000
@@ -62,6 +62,10 @@
       continues to work, but callers accessed the FORMATTERS dictionary
       directly will not.
 
+    * ``GPGStrategy.sign()`` will now raise ``BzrBadParameterUnicode`` if
+      you pass a Unicode string rather than an 8-bit string. Callers need
+      to be updated to encode first. (John Arbash Meinel)
+
   BUGFIXES:
 
     * ``bzr annotate`` now uses dotted revnos from the viewpoint of the

=== modified file 'bzrlib/gpg.py'
--- bzrlib/gpg.py	2006-10-16 01:25:46 +0000
+++ bzrlib/gpg.py	2007-02-08 16:28:05 +0000
@@ -76,6 +76,8 @@
         self._config = config
 
     def sign(self, content):
+        if isinstance(content, unicode):
+            raise errors.BzrBadParameterUnicode('content')
         ui.ui_factory.clear_term()
 
         preexec_fn = _set_gpg_tty

=== modified file 'bzrlib/tests/test_gpg.py'
--- bzrlib/tests/test_gpg.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/test_gpg.py	2007-02-08 16:28:05 +0000
@@ -80,6 +80,11 @@
             ui.ui_factory.clear_term = old_clear_term
         self.assertEqual([True], clear_term_called)
 
+    def test_aborts_on_unicode(self):
+        """You can't sign Unicode text, it must be encoded first."""
+        self.assertRaises(errors.BzrBadParameterUnicode,
+                          self.assertProduces, u'foo')
+
 
 class TestDisabled(TestCase):
 

